/* -*-mode:java; c-basic-offset:2; indent-tabs-mode:nil -*- */
package org.vi_server.javaconnectback;

import com.jcraft.jsch.*;


public class JavaConnectback{
  public static void main(String[] args){

    if (args.length!=9) {
	System.err.println("Usage: JavaConnectback user@hostname port id_dsa known_hosts bind_host bind_port connect_host connect_port respawn_period_millis");
	System.exit(1);
    }

    String rhost=args[4];//"127.0.0.1";
    int rport=Integer.parseInt(args[5]);//2299;
    String lhost=args[6];//"127.0.0.1";
    int lport=Integer.parseInt(args[7]);//22;
    int respawn = Integer.parseInt(args[8]);//60

    for (;;) {
	try{
	  JSch jsch=new JSch();

	  String host=args[0];//"vi@vi-server.org";
	  String user=host.substring(0, host.indexOf('@'));
	  host=host.substring(host.indexOf('@')+1);

	  jsch.addIdentity(args[2]);//"/home/vi/.ssh/id_dsa");
	  jsch.setKnownHosts(args[3]);//"/home/vi/.ssh/known_hosts");

	  Session session=jsch.getSession(user, host, Integer.parseInt(args[1]));

	  // username and password will be given via UserInfo interface.
	  UserInfo ui=new MyUserInfo();
	  session.setUserInfo(ui);

	  session.connect();

	  // Channel channel=session.openChannel("shell");
	  // channel.connect();

	  session.setPortForwardingR(rhost, rport, lhost, lport);

	  System.out.println(host+" "+rhost+":"+rport+" -> "+lhost+":"+lport);
	}
	catch(Exception e){
	  System.out.println(e);
	    try {
		Thread.sleep(respawn);
		continue;
	    }
	    catch(Exception e2) {
		System.out.println(e2);
	    }
	}
	break;
    }
  }

  public static class MyUserInfo implements UserInfo, UIKeyboardInteractive{
    public String getPassword(){ return null; }
    public boolean promptYesNo(String str){
	System.out.println(str);
	if (System.getenv("SSH_YES") != null) {
	    return true;
	} else {
	    return false;
	}
    }

    public String getPassphrase(){ return null; }
    public boolean promptPassphrase(String message){ return false; }
    public boolean promptPassword(String message){
	return false;
    }
    public void showMessage(String message){
      System.out.println(message);
    }
    public String[] promptKeyboardInteractive(String destination,
                                              String name,
                                              String instruction,
                                              String[] prompt,
                                              boolean[] echo){
	return null;  // cancel
    }
  }
}
